<?php
// Copyright 2005 FairlightAU
//
// Version Info
// $Header: /AudioBase3/AudioBase_Release/wavscan.php 34    12/20/11 2:54a Gary $
//
// Description: AudioBase3 WAV Scanning Engine

// Recursively scan user-defined WAV folders and publish into AudioBase3
// Get config info and shared functions
include 'config/dbconfig.php';
include 'lib/databaselib.php';
include 'config/config.php';
include 'lib/securelib.php';
include 'lib/tablelib.php';
include 'lib/ituneslib.php';
					
// Set default memory limit for old config files
if(!$config["memory_limit"])
	$config["memory_limit"]="300M";

unset($folders);
$albums=unserialize(rawurldecode(stripslashes($_GET["folders"])));
validateLanRequest();

// Check license status
$dongle=checkDongle();

if($dongle["status"] > 0)
{
	// Connect to database
	$db=safeDbConnect();
	$mysqli=$db["mysqli"];
	$link=$db["mssql_link"];

	$ab3 = new COM("Ab3Server.AB3ServerFuncs") or die("Unable to instantiate AB3Server");

	function UniqueName($destpath,$fname,$filetype,$count=NULL)
	{
		global $config;
		
		// Characters to find and replace in file names
		$badchars=array("'",":",",","&","=","/","!","|"," ","__","?","~","*","#","(",")","@","$","%","^","+","\"","`","<",">","{","}","[","]",";",".","\r","\n");
		$goodchars=array("_","","","+","_","-","_","_","_","_");
		
		// Characters to find and replace in Dream II file names
		$bad_d2_chars=array("&","=","!","|","/","?","~","*","$","%","^","\r","\n","\"");
		$good_d2_chars=array("+"," ","",""," ");

		if($filetype=="DIR")
		{
			if($config["d2"]=="1")
			{
				// Dream II Supports 255 Character Names
				$mylen=255 - (strlen($count));
	
				$outname=substr(str_replace($bad_d2_chars,$good_d2_chars,$fname),0,$mylen).$count;
				$destpath=str_replace($fname,$outname,$destpath);
			}
			else
			{
				// Get Max QDC Name length less file extension for names
				$mylen=28 - (strlen($count));

				$outname=substr(str_replace($badchars,$goodchars,$fname),0,$mylen).$count;

				$destpath=str_replace($fname,$outname,$destpath);

				//echo $fname."-".$outname."<br />";
			}

			if(is_dir($destpath) && $outname != $fname)
			{
				++$count;

				$outname["name"]=UniqueName($destpath,$outname,$filetype,$count);
			}
		}
		else
		{

			// Break filename into array at each dot
			$filearray=explode(".",$fname);

			// How many dots do we have?
			$dotcount=count($filearray) - 1;

			if($config["d2"]=="1")
			{
				// Dream II Supports 255 Character Names
				$myflen=255 - (strlen($filearray[$dotcount]) + 1);
				
				if(!$count)
				{
					$destpath=str_replace($fname.".".$filetype,"",$destpath);
				}
				
				$new_fname=substr(str_replace($bad_d2_chars,$good_d2_chars,$fname),0,$myflen).$count;
			
				$outname["fullname"] = substr(str_replace($bad_d2_chars,$good_d2_chars,$fname),0,$myflen);
				$outname["name"] =	$new_fname.".".$filetype;
				
				//echo $destpath."<br>";
			}
			else
			{
				// Get Max QDC Name length less file extension for descriptions
				$myflen=80 - (strlen($filearray[$dotcount]) + 1);

				if(!$count)
				{
					$destpath=str_replace($fname.".".$filetype,"",$destpath);
				}

				// Get Max QDC Name length less file extension for names
				$mylen=28 - (strlen($filetype) + 1) - (strlen($count));

				$new_fname=substr(str_replace($badchars,$goodchars,$fname),0,$mylen).$count;
				$outname["name"]=	$new_fname.".".$filetype;

				//echo $new_fname."<br />\n";
				//echo $outname["name"]."<br />\n";

				// Characters to find and replace in descriptions
				$bad_desc_chars=array("&","=","!","|","_","?","~","*","$","%","^","/","\r","\n");
				$good_desc_chars=array("+"," ","",""," ");

				$outname["fullname"]=substr(str_replace($bad_desc_chars,$good_desc_chars,$fname),0,$myflen);

				//echo $destpath.$outname["name"]."<br />";
			}

			if(file_exists($destpath.$outname["name"]) && $new_fname != $fname)
			{
				++$count;
			
				$outname=UniqueName($destpath,$fname,$filetype,$count);
			}
		}

		return $outname;
	}
	
	function QDCRename($string,$path)
	{
		// Rename files and directories for QDC and Web compliance.
		global $mysqli;
		global $link;
		global $config;
		global $dbconfig;
		
		// Characters to find and replace in file and folder names
		//$badchars=array("'",":",",","&","=","/","!","|"," ","__","?","~","*","#","(",")","@","$","%","^","+","\"","`","<",">","{","}","[","]",";",".");
		//$goodchars=array("_","","","+","_","-","_","_","_","_");
		
		// Check if this is a directory
		if(is_dir($path))
			$new["name"]=UniqueName($path,$string,"DIR");
		else
		{	
			$thispathinfo=pathinfo($path);

			$fname_noext=str_replace(".".$thispathinfo["extension"],"",$string);
					
			$unique=UniqueName($path,$fname_noext,$thispathinfo["extension"]);
			
			$new["name"]=$unique["name"];
			$new["fullname"]=$unique["fullname"];
		}		
		
		$new["path"]=str_replace($string,$new["name"],$path);
		$new["error"]=0;	
		
		if($path != $new["path"])
		{
			$this_rename=@rename($path,$new["path"]);
			
			// echo $path." - ".$new["path"]."<br />\n\n";
			
			if($this_rename === false)
			{
				if(is_dir($path))
				{
					print("<font face=\"Tahoma,Sans-Serif\" color=\"black\" size=\"2\"><b>The following directory could not be renamed and was skipped. Rename manually and rescan:</b><br />$path</font><br />\n");
				}
				else 
				{
					print("<font face=\"Tahoma,Sans-Serif\" color=\"black\" size=\"2\"><b>The following file could not be renamed and was skipped. Rename manually and rescan:</b><br />$path</font><br />\n");
				}
				
				flush();
				ob_flush();
				$new["error"]=1;	
			}
		}
		else
		{
			$new["path"]=$path;
		}
		
		return $new;
	}
	
	function procFile($path,$filename,$fullname,$filetype)
	{
		// Check if the vav is already in AudioBase. If not, generate a cookie and other necessary data, then add it.
		global $mysqli;
		global $link;
		global $config;
		global $dbconfig;
		global $ab3;
		
		$is_wav=0;
		$is_aif=0;
		$is_mp3=0;
		$is_sds=0;
		$mp3data["hastag"]=0;
		
		//echo $filename."<br>";
		
		if(preg_match("/wav/i",$filetype))
		{
			$is_wav=1;	
			$filetype=2;
		}	
		
		if(preg_match("/aiff/i",$filetype) || preg_match("/aif/i",$filetype))
		{
			$is_aif = 1;	
			$filetype = 100;
			$cookie = 100;
			$wavdata["fmtsr"] = -1;
			$duration = -1;
			$ed_stop = 100;
		}
		
		if(preg_match("/mp3/i",$filetype))
		{
			$is_mp3 = 1;	
			$filetype = 101;
			$cookie = 101;
			$wavdata["fmtsr"] = -1;
			$duration = -1;
			$ed_stop = 101;
		}

		if(preg_match("/sds/i",$filetype))
		{
			$is_sds = 1;	
			$filetype = 102;
			$cookie = 102;
			$wavdata["fmtsr"] = -1;
			$duration = -1;
			$ed_stop = 102;
		}
		
		if($dbconfig["sqltype"]=="mysql")
		{
			$filename=$mysqli->real_escape_string($filename);
		}
		else
		{
			$filename=str_replace("'","''",$filename);
		}
		
		if($is_wav==1)
		{
			// Bake a cookie!
			$handle = fopen($path,"rb");
			$buffer = fread($handle,65536);
			fclose($handle);
			$cookie=fairlight_cookie($buffer);
			unset($buffer);

			// Check for a matching clip in the database
			$clip_check_q="SELECT clip_no FROM ab2clips WHERE filename='$filename' AND file_cookie='$cookie'";	
		}
		else
		{
			$clip_check_q="SELECT clip_no FROM ab2clips WHERE path='".utf8_encode($path)."'";
		}
		
		if($dbconfig["sqltype"]=="mysql")
		{
			$result=$mysqli->query($clip_check_q);
			$crow=$result->num_rows;
		}
		else
		{
			$result=mssql_query($clip_check_q);
			$crow=mssql_num_rows($result);
		}
		
		//echo $clip_check_q."<br>";

		if($crow == 0)
		{
			if($is_wav==1)
			{
				// Generate ed_stop & duration
				// ed_stop = n * 48000 / r
				$wavdata=getWavData($path);			
			
				if($wavdata["fmtsr"] == 0)
				{
					print("<font face=\"Tahoma,Sans-Serif\" color=\"black\" size=\"2\"><b>'$path' does not appear to be a valid WAV file and has been skipped ...</b></font><br />\n");

					flush();
					ob_flush();
				}
				else 
				{
					$ed_stop=round($wavdata["smpltm"] * (48000 / $wavdata["fmtsr"]),0);
					$duration=$wavdata["smpltm"] / $wavdata["fmtsr"];
		
					if($wavdata["fmtchn"] > 2)
					{
						$clip_type = $wavdata["fmtchn"];
					}	
					elseif($wavdata["fmtchn"] == 2)
					{
						$clip_type = 1;
					}
					elseif($wavdata["fmtchn"] == 1)
					{
						$clip_type = 0;
					}
					else
					{
						$clip_type = 2;
					}		
			
					// Get the BWF description
					$this_bext_descr='';
					unset($description);
			
					// Steve's COM code has a bug, and does not clean up the BEXT description it has in memory until it 
					// sees another one. So, we'll only grab the BEXT chunk if we have it!
					if($wavdata["hasbext"] == 1)
					{
						$ab3->BEXT_Open($path);
						$this_bext_descr=$ab3->BEXT_ReadDescription;
						$ab3->BEXT_Close;	
					}
				}
			}
	 		elseif($is_mp3==1)
			{  
				$mp3data = GetMp3Data($path);
	    
				$clip_type = $mp3data["clip_type"];

				$wavdata["fmtsr"] = $mp3data["samplerate"];
				$duration = $mp3data["duration"];	
			}	
			elseif($is_aif==1)
			{
				$aiffdata = GetAiffData($path);
				
				$clip_type = $aiffdata["clip_type"];

				$wavdata["fmtsr"] = $aiffdata["samplerate"];
				$duration = $aiffdata["duration"];				
			}
			elseif($is_sds==1)
			{
				$clip_type = 3;
				$wavdata["fmtsr"] = 48000;
				$duration = 0;	
			}
			
			// Characters to find and replace in descriptions
			$bad_desc_chars=array("&","=","!","|","_","?","~","*","$","%","^","/","\"");
			$good_desc_chars=array("+"," ","",""," ");
			
			$filename_array=explode(".",$filename);
			$newNameSp=utf8_encode(str_replace("_"," ",$filename_array[0]));
			
			// echo $newNameSp;
			
			$folders=explode("/",$path);
			$foldercount=count($folders);
			
			if($foldercount > 3)
			{
				$lastfoldercount= $foldercount - 2;
				$lastfolder=$folders[$lastfoldercount];
			}
			
			if($config["d2"]=="1")
			{
				$stdfieldlen=255;
				$descrfieldlen=255;
			}
			else
			{
				$stdfieldlen=24;
				$descrfieldlen=80;			
			}

			// Check if the BEXT description is a Fairlight <FL> description
			if(strpos($this_bext_descr,"<FL>") === false && strlen($this_bext_descr) > 1)
			{
				// If not a Fairlight BWF, dump all of the BEXT info in the description field
				$description=substr(str_replace($bad_desc_chars,$good_desc_chars,$this_bext_descr),0,$descrfieldlen);
				$album=substr(str_replace($bad_desc_chars,$good_desc_chars,$lastfolder),0,$stdfieldlen);
			}
			elseif(strlen($this_bext_descr) > 1 && $this_bext_descr!="ERROR: Not A Broadcast WAV File")
			{
				// This is a Fairlight description
				$this_bext_descr=str_replace("<FL>","",$this_bext_descr);		
				$FL_BWF_array= explode(" : ",$this_bext_descr);
				$artist=substr(str_replace($bad_desc_chars,$good_desc_chars,$FL_BWF_array[0]),0,$stdfieldlen);
				$album=substr(str_replace($bad_desc_chars,$good_desc_chars,$FL_BWF_array[1]),0,$stdfieldlen);
				$description=substr(str_replace($bad_desc_chars,$good_desc_chars,$FL_BWF_array[2]),0,$descrfieldlen);
			}
			elseif($mp3data["hastag"]==1)
			{
				$mp3_fulldesc=$mp3data["title"] ." - ". $mp3data["genre"];
				$newNameSp = substr(str_replace($bad_desc_chars,$good_desc_chars,$mp3data["title"]),0,$stdfieldlen);
				$artist=substr(str_replace($bad_desc_chars,$good_desc_chars,$mp3data["artist"]),0,$stdfieldlen);
				$album=substr(str_replace($bad_desc_chars,$good_desc_chars,$mp3data["album"]),0,$stdfieldlen);
				$description=substr(str_replace($bad_desc_chars,$good_desc_chars,$mp3_fulldesc),0,$descrfieldlen);
			}
			else
			{
				// If not, use the lowest subfolder for category, and full name from QDCRename function for description
				$description=$fullname;
				$album=substr(str_replace($bad_desc_chars,$good_desc_chars,$lastfolder),0,$stdfieldlen);
			}
			
			// Users insist on using foreign characters, so they need to be UTF-8 Encoded
			$description=utf8_encode($description);
			$artist=utf8_encode($artist);
			$album=utf8_encode($album);
			$filename=utf8_encode($filename);
			
			if(preg_match("/".str_replace("/","\\/",$config["wav1"])."/i",$path))
			{
				$wavsrc="WAV1";
			}
			elseif(preg_match("/".str_replace("/","\\/",$config["wav2"])."/i",$path))
			{
				$wavsrc="WAV2";
			}
						
			// Create Windows compliant path for database
			$dbpath=utf8_encode(str_replace("/","\\",$path));
			
			if($dbconfig["sqltype"]=="mysql")
			{
				$dbpath=$mysqli->real_escape_string($dbpath);
				$description=$mysqli->real_escape_string($description);
				$artist=$mysqli->real_escape_string($artist);
				$album=$mysqli->real_escape_string($album);
				$filename=$mysqli->real_escape_string($filename);
				$newNameSp=$mysqli->real_escape_string($newNameSp);
			}
			else
			{
				$dbpath=str_replace("'","''",$dbpath);
				$description=str_replace("'","''",$description);	
				$artist=str_replace("'","''",$artist);
				$album=str_replace("'","''",$album);	
				$filename=str_replace("'","''",$filename);
				$newNameSp=str_replace("'","''",$newNameSp);	
			}

		
			$file_ins_q="INSERT INTO ab2files (filename,cookie,filetype,sample_rate,path,file_comment) VALUES('$filename','$cookie','$filetype','".$wavdata["fmtsr"]."','$dbpath','$wavsrc')";
			
			$clip_ins_q="INSERT INTO ab2clips (name,track,category,duration,clip_type,description,user1,user2,user3,
user4,ed_mark,ed_wave,ed_start,ed_stop,ed_hook,ed_sync,ed_fadein,ed_fadeout,ed_pan0,ed_pan1,ed_abaseid,ed_fia,ed_fis,
ed_foa,ed_fos,ed_fin,ed_fout,ed_wave2,ed_panin,ed_eqin,ed_level_db,eq_band0_freq,eq_band0_gain,eq_band0_qshelf,
eq_band1_freq,eq_band1_gain,eq_band1_qshelf,eq_band2_freq,eq_band2_gain,eq_band2_qshelf,eq_band3_freq,eq_band3_gain,
eq_band3_qshelf,ed_nlen,ed_text,filename,file_cookie) VALUES ('$newNameSp','0',
'$album','$duration','$clip_type','$description',
'$artist','','','',
'0','0','0','$ed_stop',
'0','0','0','0',
'0','0','0','0',
'0','0','0','0',
'0','0','0','0',
'0','0','0','0',
'0','0','0',
'0','0','0',
'0','0','0',
'".strlen($newNameSp)."','$newNameSp','$filename','$cookie'
)";
			
			// echo $file_ins_q."<br />";
			// echo $clip_ins_q."<br />";
			
			// Add files first, then clips
			if($dbconfig["sqltype"]=="mysql")
			{
				$mysqli->query($file_ins_q);
				$mysqli->query($clip_ins_q);
			}
			else
			{
				mssql_query($file_ins_q);
				mssql_query($clip_ins_q);
			}
			
			unset($newNameSp,$album,$duration,$description,$artist,$ed_stop,$filename,$cookie);
		}
	}
	
	function FLScanDir($tophandle,$subhandledir=NULL)
	{
		// Recurse through the specified directory, make files and directory names QDC compliant.
		
		global $mysqli;
		global $link;
		global $config;
		global $dbconfig;

		if(is_dir($tophandle))
		{
			$handle=opendir($tophandle);

			$d=1;
			$f=1;
			$s=1;

			while(false !== ($file = readdir($handle)))
			{
				if($file <> "." && $file <> ".." && $file <> ".DS_Store" && @strpos($file,'._', 0) === FALSE)
				{
					
					$filearray=explode(".",$file);
					$dotcount=count($filearray) - 1;
					
					$filetype = $filearray[$dotcount];
					
					$filetypelen=strlen($filetype);
					
					clearstatcache();
					// Check if this is a directory
					if(is_dir($tophandle."/".$file))
					{
						$subhandle=$tophandle."/".$file;
						//echo $subhandle."<br />";

						// Rename directories for QDC compliance
						$newarray=QDCRename($file,$subhandle);
						$subhandle=$newarray["path"];
						$subhandledir=$subhandle."/";

						FLScanDir($subhandle,$subhandledir);
						unset($subhandledir);
						unset($newarray);

						++$d;

						// Show the user we're busy
						if($d > 1)
						{
							print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>Finished scanning subdirectory '$file'...</b></font><br />\n");

							flush();
							ob_flush();
						}

					}
					else
					{
						if(!$subhandledir)
							$subhandledir=$tophandle."/";
								
						//echo $file."<br>";
						$this_path=$subhandledir.$file;

						// Check for a matching path in the database, and skip if one is found

						// Create Windows compliant path for database
						$this_dbpath=str_replace("/","\\",$this_path);
								
						if($dbconfig["sqltype"]=="mysql")
						{
							$this_dbpath=$mysqli->real_escape_string($this_dbpath);
						}
						else
						{
							$this_dbpath=str_replace("'","''",$this_dbpath);
						}
								
						$path_check_q="SELECT path FROM ab2files WHERE path='".utf8_encode($this_dbpath)."'";
								
						//echo $path_check_q."<br />";
								
						if($dbconfig["sqltype"]=="mysql")
						{
							$result=$mysqli->query($path_check_q);
							$prow=$result->num_rows;
						}
						else
						{
							$result=mssql_query($path_check_q);
							$prow=mssql_num_rows($result);
						}

						//echo $this_dbpath."<br />\n";

						if($prow == 0)
						{
							// Rename files for QDC compliance
							$newarray=QDCRename($file,$this_path);

							$this_path=$newarray["path"];
									
							//echo $newarray["name"]." - new<br>";
							$this_name=$newarray["name"];
									
							if(preg_match("/wav/i", $filetype) 
							|| preg_match("/mp3/i", $filetype) && $config["d2"]=="1" 
							|| preg_match("/aiff/i", $filetype) && $config["d2"]=="1" 
							|| preg_match("/aif/i", $filetype) && $config["d2"]=="1"
							|| preg_match("/sds/i", $filetype) && $config["d2"]=="1")
							{
								procFile($this_path,$this_name,$file,$filetype);
							}

							// Show the user we're busy
							if($f % 10 == 0)
							{
								print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>$f new Files scanned...</b></font><br />\n");

								flush();
								ob_flush();
							}
							++$f;
						}
						else
						{
							// Show the user we're busy
							if($s % 50 == 0)
							{
								print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>$s existing Files skipped...</b></font><br />\n");

								flush();
								ob_flush();
							}
							++$s;
						}
						unset($this_path);
						unset($this_name);
						unset($prow);	
					}
				}
			}
			closedir($handle);
		}
	}

	if($_GET["wav1"] > 0 || $_GET["wav2"] > 0)
	{
		set_time_limit(100000);

		ini_set("memory_limit",$config["memory_limit"]);
		
		print (str_repeat(" ", 256));
		print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>Starting AudioBase3 File Scanning Engine</b></font><br />\n");
		
		if ($_GET["wav1"] > 0)
		{
			print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>Scanning File Folder 1:</b> ".$config["wav1"]."</font><br />\n");
			
			flush();
			ob_flush();
			
			FLScanDir($config["wav1"]);
		}
		
		if ($_GET["wav2"] > 0)
		{
			print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>Scanning File Folder 2:</b> ".$config["wav2"]."</font><br />\n");
			
			flush();
			ob_flush();
			
			FLScanDir($config["wav2"]);
		}
		
		print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>File Scan Complete!</b></font><br />\n");
		
		ini_restore("memory_limit");

	}
	else
	{
		print("<font face=\"Tahoma,Sans-Serif\" color=\"red\" size=\"2\"><b>No Folders selected!</b></font>");
	}
	echo "<br /><center>";
	echo "<input type=\"button\" value=\"Close\" onClick=\"javascript:window.close();\">\n<br />&nbsp;\n";
	echo "</center>\n";
	
	// free the COM object
	$ab3 = null;
}
else
{
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<link rel="stylesheet" href="ab3.css" type="text/css" />
<title>
Upgrade AudioBase3
</title>
</head>
<body onLoad="window.focus()">
<?php
	echo "<form>\n<br />\n<table width=360 align=\"center\" valign=\"top\" class=\"table\" border=\"0\" cellpadding=\"2\" bgcolor=\"#FFFFFF\">";
	echo "<tr>\n<td>&nbsp;</td>\n</tr>\n";
	echo "<tr>\n<td align=\"center\">".$dongle["upsell"]."</td>\n</tr>\n";
	echo "<tr>\n<td>&nbsp;</td>\n</tr>\n";
	echo "<tr>\n<td align=\"center\"><input type=button class=submit onMouseover=\"this.className='submithover';\" onMouseout=\"this.className='submit';\" value=\"Close\" onClick=\"javascript:window.close();\">\n</td>\n</tr>\n";
	echo "<tr>\n<td>&nbsp;</td>\n</tr>\n";
	echo "</table></form>\n\n";
?>
</body>
</html>
<?php
}
?>